// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file appendableCdrAux.hpp
 * This source file contains some definitions of CDR related functions.
 *
 * This file was generated by the tool fastddsgen.
 */

#ifndef FAST_DDS_GENERATED__APPENDABLECDRAUX_HPP
#define FAST_DDS_GENERATED__APPENDABLECDRAUX_HPP

#include "appendable.hpp"

constexpr uint32_t AppendableWCharStruct_max_cdr_typesize {6UL};
constexpr uint32_t AppendableWCharStruct_max_key_cdr_typesize {0UL};

constexpr uint32_t AppendableEmptyStruct_max_cdr_typesize {4UL};
constexpr uint32_t AppendableEmptyStruct_max_key_cdr_typesize {0UL};

constexpr uint32_t AppendableULongLongStruct_max_cdr_typesize {16UL};
constexpr uint32_t AppendableULongLongStruct_max_key_cdr_typesize {0UL};

constexpr uint32_t AppendableLongLongStruct_max_cdr_typesize {16UL};
constexpr uint32_t AppendableLongLongStruct_max_key_cdr_typesize {0UL};

constexpr uint32_t AppendableInheritanceStruct_max_cdr_typesize {268UL};
constexpr uint32_t AppendableInheritanceStruct_max_key_cdr_typesize {0UL};

constexpr uint32_t AppendableLongDoubleStruct_max_cdr_typesize {24UL};
constexpr uint32_t AppendableLongDoubleStruct_max_key_cdr_typesize {0UL};

constexpr uint32_t AppendableDoubleStruct_max_cdr_typesize {16UL};
constexpr uint32_t AppendableDoubleStruct_max_key_cdr_typesize {0UL};

constexpr uint32_t AppendableUShortStruct_max_cdr_typesize {6UL};
constexpr uint32_t AppendableUShortStruct_max_key_cdr_typesize {0UL};



constexpr uint32_t AppendableUnionStruct_max_cdr_typesize {16UL};
constexpr uint32_t AppendableUnionStruct_max_key_cdr_typesize {0UL};

constexpr uint32_t AppendableExtensibilityInheritance_max_cdr_typesize {12UL};
constexpr uint32_t AppendableExtensibilityInheritance_max_key_cdr_typesize {0UL};


constexpr uint32_t AppendableShortStruct_max_cdr_typesize {6UL};
constexpr uint32_t AppendableShortStruct_max_key_cdr_typesize {0UL};

constexpr uint32_t AppendableBooleanStruct_max_cdr_typesize {5UL};
constexpr uint32_t AppendableBooleanStruct_max_key_cdr_typesize {0UL};

constexpr uint32_t AppendableEmptyInheritanceStruct_max_cdr_typesize {264UL};
constexpr uint32_t AppendableEmptyInheritanceStruct_max_key_cdr_typesize {0UL};


constexpr uint32_t AppendableOctetStruct_max_cdr_typesize {5UL};
constexpr uint32_t AppendableOctetStruct_max_key_cdr_typesize {0UL};

constexpr uint32_t AppendableCharStruct_max_cdr_typesize {5UL};
constexpr uint32_t AppendableCharStruct_max_key_cdr_typesize {0UL};


constexpr uint32_t AppendableInheritanceEmptyStruct_max_cdr_typesize {6UL};
constexpr uint32_t AppendableInheritanceEmptyStruct_max_key_cdr_typesize {0UL};


constexpr uint32_t AppendableULongStruct_max_cdr_typesize {8UL};
constexpr uint32_t AppendableULongStruct_max_key_cdr_typesize {0UL};

constexpr uint32_t AppendableFloatStruct_max_cdr_typesize {8UL};
constexpr uint32_t AppendableFloatStruct_max_key_cdr_typesize {0UL};




constexpr uint32_t AppendableLongStruct_max_cdr_typesize {8UL};
constexpr uint32_t AppendableLongStruct_max_key_cdr_typesize {0UL};







namespace eprosima {
namespace fastcdr {

class Cdr;
class CdrSizeCalculator;

eProsima_user_DllExport void serialize_key(
        eprosima::fastcdr::Cdr& scdr,
        const AppendableShortStruct& data);

eProsima_user_DllExport void serialize_key(
        eprosima::fastcdr::Cdr& scdr,
        const AppendableUShortStruct& data);

eProsima_user_DllExport void serialize_key(
        eprosima::fastcdr::Cdr& scdr,
        const AppendableLongStruct& data);

eProsima_user_DllExport void serialize_key(
        eprosima::fastcdr::Cdr& scdr,
        const AppendableULongStruct& data);

eProsima_user_DllExport void serialize_key(
        eprosima::fastcdr::Cdr& scdr,
        const AppendableLongLongStruct& data);

eProsima_user_DllExport void serialize_key(
        eprosima::fastcdr::Cdr& scdr,
        const AppendableULongLongStruct& data);

eProsima_user_DllExport void serialize_key(
        eprosima::fastcdr::Cdr& scdr,
        const AppendableFloatStruct& data);

eProsima_user_DllExport void serialize_key(
        eprosima::fastcdr::Cdr& scdr,
        const AppendableDoubleStruct& data);

eProsima_user_DllExport void serialize_key(
        eprosima::fastcdr::Cdr& scdr,
        const AppendableLongDoubleStruct& data);

eProsima_user_DllExport void serialize_key(
        eprosima::fastcdr::Cdr& scdr,
        const AppendableBooleanStruct& data);

eProsima_user_DllExport void serialize_key(
        eprosima::fastcdr::Cdr& scdr,
        const AppendableOctetStruct& data);

eProsima_user_DllExport void serialize_key(
        eprosima::fastcdr::Cdr& scdr,
        const AppendableCharStruct& data);

eProsima_user_DllExport void serialize_key(
        eprosima::fastcdr::Cdr& scdr,
        const AppendableWCharStruct& data);

eProsima_user_DllExport void serialize_key(
        eprosima::fastcdr::Cdr& scdr,
        const AppendableUnionStruct& data);

eProsima_user_DllExport void serialize_key(
        eprosima::fastcdr::Cdr& scdr,
        const AppendableEmptyStruct& data);

eProsima_user_DllExport void serialize_key(
        eprosima::fastcdr::Cdr& scdr,
        const AppendableEmptyInheritanceStruct& data);

eProsima_user_DllExport void serialize_key(
        eprosima::fastcdr::Cdr& scdr,
        const AppendableInheritanceStruct& data);

eProsima_user_DllExport void serialize_key(
        eprosima::fastcdr::Cdr& scdr,
        const AppendableInheritanceEmptyStruct& data);

eProsima_user_DllExport void serialize_key(
        eprosima::fastcdr::Cdr& scdr,
        const AppendableExtensibilityInheritance& data);


} // namespace fastcdr
} // namespace eprosima

#endif // FAST_DDS_GENERATED__APPENDABLECDRAUX_HPP

