// Copyright 2024 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @file TypeLookupServiceTestsTypes.h
 *
 */

#ifndef _TEST_DDS_XTYPES_TYPELOOKUPSERVICETEST_TYPES_H_
#define _TEST_DDS_XTYPES_TYPELOOKUPSERVICETEST_TYPES_H_

// This header will include all the headers for the types that will be tested
// They will be added automatically by the update_headers.py script

#include "../../dds-types-test/aliasesPubSubTypes.hpp"
#include "../../dds-types-test/annotationsPubSubTypes.hpp"
#include "../../dds-types-test/appendablePubSubTypes.hpp"
#include "../../dds-types-test/arraysPubSubTypes.hpp"
#include "../../dds-types-test/bitsetsPubSubTypes.hpp"
#include "../../dds-types-test/constantsPubSubTypes.hpp"
#include "../../dds-types-test/declarationsPubSubTypes.hpp"
#include "../../dds-types-test/enumerationsPubSubTypes.hpp"
#include "../../dds-types-test/finalPubSubTypes.hpp"
#include "../../dds-types-test/helpers/basic_inner_typesPubSubTypes.hpp"
#include "../../dds-types-test/inheritancePubSubTypes.hpp"
#include "../../dds-types-test/keyPubSubTypes.hpp"
#include "../../dds-types-test/mapsPubSubTypes.hpp"
#include "../../dds-types-test/mutablePubSubTypes.hpp"
#include "../../dds-types-test/optionalPubSubTypes.hpp"
#include "../../dds-types-test/primitivesPubSubTypes.hpp"
#include "../../dds-types-test/sequencesPubSubTypes.hpp"
#include "../../dds-types-test/stringsPubSubTypes.hpp"
#include "../../dds-types-test/structuresPubSubTypes.hpp"
#include "../../dds-types-test/unionsPubSubTypes.hpp"
#include "BaseCasesIDLs/XtypesTestsType1PubSubTypes.hpp"
#include "BaseCasesIDLs/XtypesTestsType2PubSubTypes.hpp"
#include "BaseCasesIDLs/XtypesTestsType3PubSubTypes.hpp"
#include "BaseCasesIDLs/XtypesTestsTypeBigPubSubTypes.hpp"
#include "BaseCasesIDLs/XtypesTestsTypeDepPubSubTypes.hpp"
#include "BaseCasesIDLs/XtypesTestsTypeNoTypeObjectPubSubTypes.hpp"

#endif /* _TEST_DDS_XTYPES_TYPELOOKUPSERVICETEST_TYPES_H_ */
